﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Aspose.Slides;
using Aspose.Slides.Charts;
using Aspose.Slides.Export;
using System.Reflection;

namespace HOTPathchAsposeSlides
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Crack();//调用Crack方法实现软破解


            //实例化ppt文件
            Presentation pres = new Presentation();           
           
            //第一个幻灯片
            ISlide sld0 = pres.Slides[0];
            sld0.Shapes.Clear();          
            IAutoShape ashp = sld0.Shapes.AddAutoShape(ShapeType.Rectangle, 50, 100, 500, 100); //添加形状            
            ashp.FillFormat.FillType = FillType.NoFill;//背景不填充
            ITextFrame tf = ashp.TextFrame;//添加一个文本框  
            tf.Text = "Hello 52Pojie !!!";//文本
            IPortion port = tf.Paragraphs[0].Portions[0];//文本段落            
            port.PortionFormat.LatinFont = new FontData("黑体");
            port.PortionFormat.FontBold = NullableBool.True;  //加粗      
            port.PortionFormat.FontHeight = 50;//大小

            port.PortionFormat.FillFormat.FillType = FillType.Solid;
            port.PortionFormat.FillFormat.SolidFillColor.Color = System.Drawing.Color.Red;//颜色 

            //创建个空的幻灯片       
            pres.Slides.AddEmptySlide(pres.LayoutSlides[0]);
            //第二个幻灯片
            ISlide sld = pres.Slides[1];
            //删除默认生成的形状框
            sld.Shapes.Clear();
            // 添加图表
            IChart chart = sld.Shapes.AddChart(ChartType.ClusteredColumn, 100, 10, 500, 500);
            //添加图表标题            
            chart.ChartTitle.AddTextFrameForOverriding("52Pojie");
            chart.ChartTitle.TextFrameForOverriding.TextFrameFormat.CenterText = NullableBool.True;
            chart.ChartTitle.Height = 20;
            chart.HasTitle = true;            
            chart.ChartData.Series[0].Labels.DefaultDataLabelFormat.ShowValue = true;
            //设置图表数据表的索引
            int defaultWorksheetIndex = 0;
            //实例化图表数据表
            IChartDataWorkbook fact = chart.ChartData.ChartDataWorkbook;
            //删除默认生成的系列和类别
            chart.ChartData.Series.Clear();
            chart.ChartData.Categories.Clear();
            int s = chart.ChartData.Series.Count;
            s = chart.ChartData.Categories.Count;

            //添加新系列
            chart.ChartData.Series.Add(fact.GetCell(defaultWorksheetIndex, 0, 1, "北京雾霾指数"), chart.Type);
            chart.ChartData.Series.Add(fact.GetCell(defaultWorksheetIndex, 0, 2, "天津雾霾指数"), chart.Type);
            chart.ChartData.Series.Add(fact.GetCell(defaultWorksheetIndex, 0, 3, "三亚雾霾指数"), chart.Type);
            //添加新类别
            chart.ChartData.Categories.Add(fact.GetCell(defaultWorksheetIndex, 1, 0, "一月"));
            chart.ChartData.Categories.Add(fact.GetCell(defaultWorksheetIndex, 2, 0, "二月"));
            chart.ChartData.Categories.Add(fact.GetCell(defaultWorksheetIndex, 3, 0, "三月"));

            //设置第一个系列表（即对北京雾霾数据进行操作）
            IChartSeries series = chart.ChartData.Series[0];
            //开始填充北京数据
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 1, 1, 150));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 2, 1, 200));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 3, 1, 100));
            //设置填充颜色
            series.Format.Fill.FillType = FillType.Solid;
            series.Format.Fill.SolidFillColor.Color = Color.Red;

            //设置第二个系列表（即对天津雾霾数据进行操作）
            series = chart.ChartData.Series[1];
            //开始填充天津数据
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 1, 2, 30));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 2, 2, 10));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 3, 2, 60));
            //设置填充颜色
            series.Format.Fill.FillType = FillType.Solid;
            series.Format.Fill.SolidFillColor.Color = Color.Green;

            //设置第三个系列表（即对三亚雾霾数据进行操作）
            series = chart.ChartData.Series[2];
            //开始填充天津数据
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 1, 3, 5));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 2, 3, 10));
            series.DataPoints.AddDataPointForBarSeries(fact.GetCell(defaultWorksheetIndex, 3, 3, 20));
            //设置填充颜色
            series.Format.Fill.FillType = FillType.Solid;
            series.Format.Fill.SolidFillColor.Color = Color.Yellow;
            
            //保存
            pres.Save(@"C:\AsposeSlides.pptx", SaveFormat.Pptx);
            MessageBox.Show(@"生成成功，文件保存在：C:\AsposeSlides.pptx");
        }


        private static void Crack()//使用前调用一次即可
        {
            string[] stModule = new string[8]
            {
                "\u0002\u2006\u2006\u2003",
                "\u0003\u2006\u2006\u2003",
                "\u0005\u2005\u2000\u2003",
                "\u0003\u2000",
                "\u000F",
                "\u0002\u2000",
                "\u0003",
                "\u0002"
            };
            Assembly assembly = Assembly.GetAssembly(typeof(Aspose.Slides.License));


            Type typeLic = null, typeIsTrial = null, typeHelper = null;

            foreach (Type type in assembly.GetTypes())
            {
                if ((typeLic == null) && (type.Name == stModule[0]))
                {
                    typeLic = type;
                }
                else if ((typeIsTrial == null) && (type.Name == stModule[1]))
                {
                    typeIsTrial = type;
                }
                else if ((typeHelper == null) && (type.Name == stModule[2]))
                {
                    typeHelper = type;
                }
            }
            if (typeLic == null || typeIsTrial == null || typeHelper == null)
            {
                throw new Exception();
            }
            object lic = Activator.CreateInstance(typeLic);
            int findCount = 0;

            foreach (FieldInfo field in typeLic.GetFields(BindingFlags.NonPublic | BindingFlags.Static | BindingFlags.Instance))
            {
                if (field.FieldType == typeLic && field.Name == stModule[3])
                {
                    field.SetValue(null, lic);
                    ++findCount;
                }
                else if (field.FieldType == typeof(DateTime) && field.Name == stModule[4])
                {
                    field.SetValue(lic, DateTime.MaxValue);
                    ++findCount;
                }
                else if (field.FieldType == typeIsTrial && field.Name == stModule[5])
                {
                    field.SetValue(lic, 1);
                    ++findCount;
                }

            }
            foreach (FieldInfo field in typeHelper.GetFields(BindingFlags.NonPublic | BindingFlags.Static | BindingFlags.Instance))
            {
                if (field.FieldType == typeof(bool) && field.Name == stModule[6])
                {
                    field.SetValue(null, false);
                    ++findCount;
                }
                if (field.FieldType == typeof(int) && field.Name == stModule[7])
                {
                    field.SetValue(null, 128);
                    ++findCount;
                }
            }
            if (findCount < 5)
            {
                throw new NotSupportedException("无效的版本");
            }
        }
    }
}
